
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */


#include "base/polygraph.h"

#include "xstd/h/iostream.h"

#include "base/BStream.h"


/* BinIos */

BinIos::~BinIos() {
}

/* IBStream */

IBStream::IBStream(): theStream(0) {
}

IBStream::~IBStream() {
}

void IBStream::configure(istream *aStream, const String &aName) {
	Assert(!theStream && aStream);
	theStream = aStream;
	theName = aName;
}

String &IBStream::gets(String &s) {
	const int len = geti();
        Must(len >= 0);
        s.alloc(len+1);
        if (len)
                get(s.buf(), len);
        return s;
}

void IBStream::get(void *buf, Size size) {
	Assert(theStream);
	theStream->read((char*)buf, size);
	theOff += size;
}

void IBStream::skip(Size size) {
	theStream->seekg((streamoff)size, ios::cur);
	theOff += size;
}

/* OBStream */

OBStream::OBStream(): theStream(0) {
}

OBStream::~OBStream() {
}

void OBStream::configure(ostream *aStream, const String &aName) {
	Assert(!theStream && aStream);
	theStream = aStream;
	theName = aName;
}

void OBStream::put(const void *buf, Size size) {
	Assert(theStream);
	theStream->write((const char*)buf, size);
	theOff += size;
}

void BStream::configure(iostream *aStream, const String &aName) {
	IBStream::configure(aStream, aName);
	OBStream::configure(aStream, aName);
}
