
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PGL_ADDRESS_MAP_SYMBOL_H
#define PGL_ADDRESS_MAP_SYMBOL_H

#include "xstd/Array.h"
#include "pgl/PglRecSym.h"

class NetAddr;

// parameters for object life cycle model
class AddrMapSym: public RecSym {
	public:
		AddrMapSym();
		AddrMapSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;

		String zone() const;
		bool addresses(Array<NetAddr*> &addrs) const;
		bool names(Array<NetAddr*> &nms) const;
		const ArraySym *addressesSym() const;
		const ArraySym *namesSym() const;

	protected:
		virtual SynSym *dupe(const String &dType) const;
};

#endif
