
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PGL_LIST_SYMBOL_H
#define PGL_LIST_SYMBOL_H

#include "xstd/Array.h"
#include "pgl/pglSyms.h"

// list of symbols of a any types
class ListSym: protected Array<SynSym*>, public ExpressionSym {
	public:
		ListSym(const String &aType = "List");
		virtual ~ListSym();

		virtual bool isA(const String &type) const;

		int count() const { return Array<SynSym*>::count(); }
		const SynSym *operator [](int idx) const { return item(idx); }
		const SynSym *item(int idx) const { return Array<SynSym*>::item(idx); }

		void add(const SynSym &s);
		void clear();

		virtual ostream &print(ostream &os, const String &pfx) const;

	protected:
		virtual SynSym *dupe(const String &dType) const;

		bool absorb(const ListSym &arr);
		void doAdd(SynSym *sclone);

		virtual void addFailure(const SynSym &s);
		virtual bool cadd(const SynSym &s);
};

#endif
