
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "pgl/pgl.h"

#include "xstd/Assert.h"
#include "xstd/String.h"
#include "pgl/PopDistr.h"
#include "pgl/PglPopDistrSym.h"


// XXX: we are leaking pop distributions here as they are never deleted!

PopDistrSym::PopDistrSym(const String &aType, PopDistr *aVal): 
	ExpressionSym(aType), theVal(aVal) {
}

PopDistrSym::~PopDistrSym() {
}

bool PopDistrSym::isA(const String &type) const {
	return ExpressionSym::isA(type) || type == "PopDistr";
}

SynSym *PopDistrSym::dupe(const String &type) const {
	if (isA(type)) {
		PopDistrSym *d = new PopDistrSym(this->type(), theVal);
		return d;
	}
	return ExpressionSym::dupe(type);
}

ostream &PopDistrSym::print(ostream &os, const String &) const {
	if (theVal)
		theVal->print(os);
	else
		os << "<none>";
	return os;
}
