
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PGL_STRING_SYMBOL_H
#define PGL_STRING_SYMBOL_H

#include "pgl/PglExprSym.h"

class String;

// a string

class StringSym: public ExpressionSym {
	public:
		StringSym(const String &aVal): ExpressionSym("string"), theVal(aVal) {}

		virtual bool isA(const String &type) const;

		const String &val() const { return theVal; }
		void val(const String &aVal) { theVal = aVal; }

		virtual ostream &print(ostream &os, const String &pfx = 0) const;

	protected:
		virtual SynSym *dupe(const String &dType) const;

	protected:
		String theVal;
};

#endif
