
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_RPTMSTAT_H
#define PG_RPTMSTAT_H

#include "xstd/AlarmClock.h"
#include "base/AggrStat.h"
#include "runtime/BcastRcver.h"

class RptmstatSym;
class StatPhase;

// response time "thermostat"
class Rptmstat: public AlarmUser, public BcastRcver {
	public:
		static bool IsEnabled; // XXX: to disable on server-side

	public:
		Rptmstat();

		void configure(const RptmstatSym &cfg);

		void start(StatPhase *aPhase);
		void stop(StatPhase *aPhase);

		virtual void wakeUp(const Alarm &alarm);
		virtual void noteXactEvent(BcastChannel *, const Xaction *);

	protected:
		void changeLoad(double delta);
		void nextSample();
		void checkpoint();

	protected:
		Time theSampleDur;   // sampling interval
		Time theRptmMin;     // rptm goals
		Time theRptmMax;
		double theLoadDelta; // reactivity

		StatPhase *thePhase;
		AggrStat theRptm;    // current measurements
};

#endif
