
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef SHARED_OPTS
#define SHARED_OPTS

#include "base/opts.h"
#include "base/polyOpts.h"

// options shared by client and server sides
class SharedOpts: public OptGrp {
	public:
		SharedOpts(); // defaults

		virtual bool validate() const;
		
	public:
		HelpOpt theHelpOpt;
		VersionOpt theVersOpt;
		HostTypeOpt theHostTypeOpt;

		IntOpt theVerbLevel;
		DumpFlagsOpt theDumpFlags;
		SizeOpt theDumpSize;
		NetAddrOpt theNotifAddr;
		NetAddrOpt theBeepDoormanListAt;
		NetAddrOpt theBeepDoormanSendTo;
		StrOpt theRunLabel;

		IntOpt theFDLimit;

		StrOpt theCfgFileName;
		StrArrOpt theCfgDirs;

		StrOpt theConsFileName;
		StrOpt theLogFileName;
		SizeOpt theLogBufSize;
		StrOpt theSmplLogFileName;
		SizeOpt theSmplLogBufSize;

		TimeOpt theStatCycleLen;

		FileScanOpt theFileScanner;
		IntOpt thePrioritySched;

		StrArrOpt theFakeHosts;
		BoolOpt deleteOldAliases;

		TimeOpt theIdleTout;

		IntOpt theLclRngSeed;
		IntOpt theGlbRngSeed;
		BoolOpt useUniqueWorld;
};

extern SharedOpts TheOpts;

#endif
