
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "runtime/AddrMap.h"
#include "runtime/Viserv.h"


Viservs TheViservs;


/* Viserv */

Viserv::Viserv(int aName): theName(aName) {
}


/* Viservs */

int Viservs::nameIdxAt(int viserv) const {
	Assert(0 <= viserv && viserv < count());
	return item(viserv).theName;
}

const NetAddr &Viservs::nameAt(int viserv) const {
	return TheAddrMap->nameAt(nameIdxAt(viserv));
}

bool Viservs::find(int nameIdx, int &idx) const {
	for (idx = 0; idx < count(); ++idx) {
		if (item(idx).theName == nameIdx)
			return true;
	}

	return false;
}

void Viservs::add(int name) {
	append(Viserv(name));
}

